// RamStoreStream.h
//	Copyright:	 1994 - 1998 by Apple Computer, Inc., all rights reserved.


#pragma once
#include "IAStoreStream.h"
#include <stdio.h>
class LHandleStream;

class RamStoreStream : public IAStoreStream
{
	public:
				RamStoreStream(LHandleStream* _myStream);
//				RamStoreStream(RamStoreStream& s) : IAStoreStream(s) {}
				~RamStoreStream();
	
		void	Initialize();
		void	Open(bool writeable);
		bool	IsOpen();
		void	Flush();
	
		uint32	GetEOF();
		void	SetEOF(uint32 address);
		
		virtual bool 			IsWritable( void );
		virtual IAStoreStream* 	Clone( void );

	protected:
		void	Write(uint32 address, const byte* data, uint32 length);
		uint32	Read(uint32 address, byte* data,  uint32 length);
		bool	am_open;
	
	private:
		LHandleStream* myStream;
		
		//char*			fileName;	// used just for identification when debugging
	
		// OS-specific methods
		//void				SetFileType(char* filename);
};



